
	.INCLUDE inc\global.inc
	.INCLUDE inc\dpfpu.inc
	
.LIST on

; save 10 bytes in stack plus 3 bytes for return address
PUSHED	.EQU	13	; return address + pushed register's
PUSHED1	.EQU	15	; count is in top of return address
NLOCALS	.EQU	64
COUNTOFS	.EQU	(PUSHED + NLOCALS + 1)

FMTPARAM	.EQU	0

; locals in stack accessed by DPR
_PRINTFDP:	.SECTION page0, common, ref_only, offset 0

mvfrom		.DW
mvto		.DW
pparams		.DW
fmtidx		.DW	; current index to format string
lpfmt		LP	; long pointer to format string
lpdest		LP	; long pointer to dest. string
dsize		.DW	; dest. string size
putopts		.DB	; putter options
			; <7>: 0 => file/stream - 1 => string
			; <6>: if <7> = 0 => 0 => file - 1 => stream
			; <6>: if <7> = 1 => 0 => alloc string - 1 => use dest
putopts2	.DB	; <7>: 0 => no store - 1 +> store			
fpusave		.DW	; pointer to fpu saved direct-page
fmtflag		.DB	; format flags (see F_XXX constants)
fmtmod		.DB	; modifier's bit's (see F2_XXX constants)
fmtwidth	.DB	; [width] field value
fmtprec		.DB	; [precision] field value
fmtsgn		.DB	; formattation sign
fbtmp		.DB	; temp. byte
tfloat		.DB	; float conversion type (see FF_XXX constants)
fpuuse		.DB	; signal that current conversion use fpu emulator

LOCALSIZE	.DS	0

		.ENDS

; locals
;mvfrom		.EQU	0
;mvto		.EQU	2
;pformat		.EQU	4

;---------------------------------------------------------------------------
; equates
;---------------------------------------------------------------------------

; spec's class
_dc		.EQU	0	; don't care
_si		.EQU	1	; sign fill +/-
_af		.EQU	2	; alternate form
_ar		.EQU	3	; format (width or precision) by argument
_lj		.EQU	4	; left justify
_pr		.EQU	5	; precision
_nu		.EQU	6	; numeral
_lo		.EQU	7	; long integer (64 bit)
_sh		.EQU	8	; short integer (16 bit)
_SH		.EQU	9	; byte (8 byte)
_fz		.EQU	10	; fill zeros
_de		.EQU	11	; signed decimal
_un		.EQU	12	; unsigned decimal
_he		.EQU	13	; hexadecimal (lower case digits)
_pt		.EQU	14	; long pointer (lower case digits)
_HE		.EQU	15	; hexadecimal (upper case digits)
_PT		.EQU	16	; long pointer (upper case digits)
_ch		.EQU	17	; char
_st		.EQU	18	; string (ASCIIZ)
_ff		.EQU	19	; float %f
_fe		.EQU	20	; float %e
_fg		.EQU	21	; float %g
_FE		.EQU	22	; float %E
_FG		.EQU	23	; float %G
_tg		.EQU	24	; thousand group
_ll		.EQU	25	; long long integer (128 bits)
_PS		.EQU	26	; pascal/basic string
_xf		.EQU	27	; hex float (lower case digits)
_XF		.EQU	28	; hex float (upper case digits)
_kf		.EQU	29	; compact hex float
_KF		.EQU	30	; compact hex float (upper case digits)
_FF		.EQU	31	; float %F

; fmtflag bits
F_ALTFMT	.EQU	$80	; alternate format
F_LEFTJ		.EQU	$40	; left justify (default: right)
F_FILLZ		.EQU	$20	; fill with '0' digit
F_GROUP		.EQU	$10	; thousand group
F_WIDTH		.EQU	$08	; 'width' field is valid
F_PREC		.EQU	$04	; 'precision' field is valid

; fmtmod modifier's bits
F2_PSSTRING	.EQU	$80	; pascal/basic string (default: ASCIIZ)
F2_LONGLONG	.EQU	$40	; integer long long modifier
F2_LONG		.EQU	$20	; integer long modifier 
F2_SHORT	.EQU	$10	; integer short modifier
F2_BYTE		.EQU	$08	; integer byte modifier
F2_CAPS		.EQU	$04	; upper case hexadecimal digits
F2_SIGNED	.EQU	$01	; signed integer

; tfloat values: float format type
FF_EXP		.EQU	'E'	; e/E format
FF_STD		.EQU	'F'	; f/F format
FF_G		.EQU	$40	; g/G format
FF_HEX		.EQU	$04	; a/A format

; valid integer modifier's mask
MASKMOD		.EQU	(F2_LONG.OR.F2_SHORT.OR.F2_BYTE.OR.F2_LONGLONG)

; invalid modifier mask for '%c' format
MASKCHAR	.EQU	(MASKMOD.OR.F2_PSSTRING)

; invalid modifier mask for '%s' format
MASKSTR		.EQU	(MASKMOD)

; invalid modifier mask for '%p' format
MASKPTR		.EQU	(MASKCHAR)

; invalid modifier mask for float format
MASKFLOAT	.EQU	(MASKMOD.OR.F2_PSSTRING)

; invalid modifier mask for integer
MASKINTG	.EQU	(F2_PSSTRING)

; conversion function index 
T_CHAR		.EQU	0	; character
T_STR		.EQU	(1 * 2)	; string
T_PTR		.EQU	(2 * 2)	; long pointer
T_INT		.EQU	(3 * 2)	; integer
T_HEX		.EQU	(4 * 2)	; hexadecimal
T_FLOAT		.EQU	(5 * 2)	; float

; current stage while scan format
FLAGSTAGE	.EQU	0	; [flag] stage
FILLZSTAGE	.EQU	1	; fill with '0' stage
WIDESTAGE	.EQU	2	; [width] stage
DOTSTAGE	.EQU	3	; ['.'] stage
PRECSTAGE	.EQU	4	; [precision] stage
MODSTAGE	.EQU	5	; [modifier] stage

; snprintf(str, size, format, ..., count)
; str:	dest string
; size:	size of dest
; format: format string
; count: bytes count of variables param's
;
; P = 10 => bytes's count of know param's (str->3, size->2, format->3, count->2)
; M = byte's count of variables param's (stored in count)

KNOWPAR		.SET	8

; prologue
prologue	.MACRO	npars

	.MLIST
	.LONGA	off
	.LONGI	off

	php			; save status
	phb			; save DBR
	phd			; save DPR

	; CPU 16 + CLC
	rep	#(PMFLAG.OR.PXFLAG.OR.PCFLAG)
	.LONGA	on
	.LONGI	on

	pha			; save A
	phx			; save X
	phy			; save Y
	tsx
	txa			; A = old frame stack
	;sbc	#NLOCALS-1
	sbc	#LOCALSIZE-1
	tcs			; new stack pointer
	inc	a
	tcd			; DPR point to locals base
	txa
	clc
	adc	#PUSHED
	sta	mvfrom		; pointer to source frame stack to move
	inc	a
	inc	a		; pointer to top of count param (countH)
	adc	COUNTOFS,s	; add size of variables param's
	tax
	inx			; pointer to format param
	stx	pparams		; pointer to top + 1 of variables param's
	adc	#npars
	sta	mvto		; pointer to dest. frame stack to move	
	
	; ACC 08
	sep	#PMFLAG
	.LONGA	off

	lda	#0
	pha
	phb			; DBR => bank 0
	ldy	.ABS.FMTPARAM,x
	sty	lpfmt
	lda	.ABS.FMTPARAM+2,x
	sta	lpfmt+2

	.MNLIST
	.ENDM


	.CODEFA

; cprintf(format, ..., count)
_cprintf:

	; prologue code (leave index 16 bit)
	prologue	3
	.LONGI	on
	
	CPU08
	
; epilogue
epilogue:
	CPU16CLC
	ldx	mvfrom		; source pointer for data move
	ldy	mvto		; dest pointer for data move
	lda	#PUSHED-1	; move bytes count - 1
	mvp	#0, #0		; cleanup stack
	tya			; new stack pointer
	tcs
	ply			; restore registers
	plx
	pla
	pld
	plb
	plp
	rtl

; common formattation routine
_vprinter:
	.LONGA	off
	.LONGI	off

	ldy	#0
	INDEX16

	; parse format string
?nxt:	lda	[lpfmt],y	; get next char from format string
	bne	$+5
	;beq	?done		; end of format string (?60)
	jmp	?done		; end of format string (?60)
	cmp	#'%'
	beq	?nxt1		; found specifier
?put:	jsr	_store		; put character "as is"
	iny			; bump pointer
	bra	?nxt		; continue parsing
?nxt1:	sty	fmtidx		; save index to '%' char
	iny
	lda	[lpfmt],y	; get next char after specifier
	cmp	#'%'
	beq	?put		; put literal '%' and continue
	
	; check format after specifier '%'
	lda	#0		; A = stage = 0 (current stage) 
	sta	fmtsgn		; clear working var's
	sta	fmtflag
	sta	fmtmod	
	sta	fmtwidth
	sta	fmtprec
	bra	?lpf1		; reload current char
	
?lpf:	iny			; loop format parsing
?lpf1:	xba			; B = stage
	lda	[lpfmt],y	; A = next char after specifier '%'
	beq	?err		; end of format string: abandon (?50)
	sta	fbtmp		; save char
	sec
	sbc	#' '		; scale char to 0..5F
	bcc	?err		; illegal char at this stage
	cmp	#(128 - ' ')
	bcs	?err		; illegal char at this stage
	sty	fmtidx		; save current index
	CPU08			; all registers 8 bit
	tax			; X = 0..5F
	lda	>CLASSCHR,x	; A = class char lookup
	asl	a
	tax			; function index
	lda	fbtmp		; A = current char
	xba			; B = current char, A = current stage
				; ZF = 1 if current stage = 0
	jsr	(CHKTBL,x)	; check format specifier at this stage
	INDEX16			; X/Y => 16 bits
	ldy	fmtidx		; Y = index to format string
	bcs	?err		; format error - abandon
	bvc	?lpf		; continue format parsing
	
	; at this point the format specifier was recognized and we assume
	; that was parsed correctly and X hold the index to the right
	; function that get parameter(s) from stack and convert in string.
	; If the conversion function use fpu emulator we save the direct-page
	; used by fp emulator to a local page in stack (for reentrancy)
	cpx	#T_PTR		; use fpu emulator?
	bcc	?cvt		; no
	bit	fpuuse		; already saved fpu direct-page?
	bmi	?cvt		; yes
	phx			; save conversion function index
	CPU16CLC
	tsc
	sbc	#255		; make room for 256 bytes
	tcs
	inc	a		; pointer to local 
	sta	fpusave
	tay			; destination for move 
	ldx	#P0FPU		; source page for move
	lda	#255		; move 256 bytes
	mvn	#0, #0		; move in bank 0
	plx			; restore function index
	
?cvt:	CPU08
	jsr	(CVTTBL,x)	; call conversion function
	INDEX16
	ldy	fmtidx		; Y = index to format string
	iny			; bump pointer
	bra	?nxt		; parse next char

	; ABANDON - causa errore specificatore di formato si suppone che i
	; parametri non siano piu' allineati con il formato
	; viene quindi copiato letteralmente il resto di szFmt a partire
	; dal carattere '%' dove si e' verificato il disallineamento, fino
	; alla fine della stringa szFmt
?err:	ldy	fmtidx			; indice al carattere '%'
?err1:	lda	[lpfmt],y		; copia da szFmt a szDst
	beq	?done			; fino a fine stringa
	iny
	jsr	_store
	bra	?err1

?done:	bit	fpuuse
	bpl	?end
	CPU16
	ldx	fpusave		; source of move 
	ldy	#P0FPU
	lda	#255
	mvn	#0, #0		; move in bank 0
	CPU08	

?end:

_store:
putter:
	ldy	dsize
	bit	putopts
	bpl	?put		; put to file/stream
	bvc	?inc		; not store this byte in dest. string
	cpy	dsize		; exceed dest. string size?
	bcs	?done		; yes => no store, no increment counter
	bra	?sto		; store char in string
?put:	cpy	dsize		; local buffer is full?
	bcc	?sto		; no, store char in local buffer
	sta	fbtmp		; save current char
	jsr	lflush		; flush local buffer
	lda	fbtmp		; restore current char
?sto:	sta	[lpdest],y	; store char in local buffer
?inc:	iny			; incremet counter
	sty	dsize		; save current size of buffer 
?done:	rts

; flush local buffer	
lflush:
	lda	#0
	sta	[lpdest],y	; terminate local buffer
	tyx
	beq	?done		; empty buffer
	lda	lpdest+1	; C = buffer address
	xba
	lda	lpdest
	ldx	#0		; bank 0
	txy
	TXTSTROUT		; preserve A,X,Y
?done:	rts	

;---------------------------------------------------------------------------
; specifier format parsing/checking - funtions that checks type and modifiers
;
; In	- B = parsed char, A = current stage
;	- ZF = 1 if current stage = 0
;
; Out	- CF = 1 => error, unknow type or modifier not allowed
;	  CF = 0, VF = 1, X = conversion function index => end current parsing
;	  CF = 0, VF = 0 => continue parsing
;---------------------------------------------------------------------------

	.LONGA	off
	.LONGI	off

; case ' ' or '+' -- only valid while stage = 0
case_si:
	bne	case_dc			; error: not in stage = 0
	ldx	fmtsgn
	cpx	#'+'
	beq	case_cont		; ignore ' ' if '+' already specified
	xba				; A = current char - B = stage
	sta	fmtsgn			; store sign byte
	xba				; A = stage
case_cont:
	clc				; OK
	clv				; continue parsing
	rts

; case digit '0' - meaning depend on current stage
; if stage = 0: left padding with digit '0' instead of blank ' '
; if stage > 0 then '0' is a digit of [width] or [precision] filkeds
case_fz:
	bne	case_nu			; stage > 0 => handle width/precision
	tax				; X = stage
	lda	#F_LEFTJ
	bit	fmtflag			; ignore padding with '0'...
	beq	?skp			; ... if not right just.
	txa				; A = stage
	bne	case_cont		; continue parsing
?skp:	lda	#F_FILLZ		; padding with '0'
	inx				; X = 1 -> FILLZSTAGE
	bra	setflag			; after should follow width stage

; case '-'  -- only valid while stage = 0
case_lj:
	bne	case_dc			; stop parsing
	tax				; X = stage
	lda	#F_LEFTJ		; set left justify bit
	bra	setflag
	
; case '#' -- only valid while stage = 0
case_af:
	bne	case_dc			; stop parsing
	tax				; X = stage
	lda	#F_ALTFMT		; alternate format bit

; set current parsed flags
setflag:
	tsb	fmtflag
	txa				; A = stage
	clc				; OK
	clv				; continue parsing
	rts

; case ',' -- only valid while stage = 0
case_tg:
	bne	case_dc			; stop parsing
	tax				; X = stage
	lda	#F_GROUP		; set group thousand bit 
	bra	setflag
	
; case '*' -- [width] or [precision] field passed by argument
case_ar:
	xba				; save stage
	INDEX16
	ldx	pparams			; get byte parameter
	dex				; align to next byte param
	lda	.ABS.FMTPARAM,x
	stx	pparams
	INDEX08
	tax				; X = param
	xba				; A = stage
	cmp	#WIDESTAGE
	bcs	?nxt			; WIDESTAGE or above stage
	stx	fmtwidth		; store width
	lda	#F_WIDTH
	tsb	fmtflag			; set 'width' bit
	lda	#DOTSTAGE		; expected next stage: [.precision]
	clc				; OK
	clv				; continue parsing
	rts
?nxt:	cmp	#PRECSTAGE
	bne	case_dc			; discard: unexpected stage level
	stx	fmtprec			; store precision
	tax				; X = stage
	lda	#F_PREC
	tsb	fmtflag			; set 'precision' bit
	txa				; A = stage: keep current stage
	clc				; OK
	clv				; continue parsing
	rts	
	
; unknow chracter was parsed - sjip
case_dc:
	sec				; error flag
	rts

; case '0'..'9' - digit tht are part of [width] or [precision]
; fmtwidth and fmtprec are set to zero before enter parsing routine
case_nu:
	tax				; X = stage
	xba				; A = char '0'..'9'
	sec
	sbc	#'0'			; scale to 0..9
	cpx	#WIDESTAGE+1		; part of [width] field ?
	bcs	?nxt			; no
	tax				; X = number 0..9
	lda	fmtwidth
	stx	fmtwidth
	beq	?z			; old width = 0 
	asl	a			; width * 2
	bcs	?err			; overflow
	sta	fbtmp
	asl	a
	bcs	?err			; overflow
	asl	a			; width * 8
	bcs	?err			; overflow
	adc	fbtmp			; width * 10
	bcs	?err			; overflow
	adc	fmtwidth		; (width * 10) + number
	bcs	?err			; overflow
	sta	fmtwidth
?z:	lda	#F_WIDTH
	tsb	fmtflag			; set 'width' bit
	lda	#WIDESTAGE		; set current stage: 'width'
	clc				; OK
	clv				; continue parsing
	rts
?nxt:	cpx	#PRECSTAGE		; precision stage ? 
	bne	case_dc			; no -- skip
	tax				; X = number 0..9
	lda	fmtprec
	stx	fmtprec
	beq	?z1			; old prec = 0 
	asl	a			; prec * 2
	bcs	?err			; overflow
	sta	fbtmp
	asl	a
	bcs	?err			; overflow
	asl	a			; prec * 8
	bcs	?err			; overflow
	adc	fbtmp			; prec * 10
	bcs	?err			; overflow
	adc	fmtprec			; (prec * 10) + number
	bcs	?err			; overflow
	sta	fmtprec
?z1:	xba				; keep current stage
	clc				; OK
	clv				; continue prsing
?err:	rts

; case '.' -- only valid if current stage < PRECSTAGE
case_pr:
	cmp	#PRECSTAGE
	bcs	?err			; skip
	lda	#F_PREC
	tsb	fmtflag			; set 'precision' bit
	lda	#PRECSTAGE		; set current stage
	clc				; OK
	clv				; continue parsing
?err:	rts

;============================================================================
; modificatori -- impostano lo stato MODSTAGE (dopo sono ammessi solo i tipi)

; case 'l' -- 'long' modifier (64 bit integer)
case_lo:
	ldx	#F2_LONG
	bra	setmod

; case 'h' -- 'short' modifier (16 bit integer)
case_sh:
	ldx	#F2_SHORT
	bra	setmod

; case 'b' -- 'byte' modifier (8 bit integer)
case_SH:
	ldx	#F2_BYTE
	bra	setmod

; case 'L' -- 'long long' modifier (128 bit integer)
case_ll:
	ldx	#F2_LONGLONG
	bra	setmod
	
; case 'B' -- 'pascal/basic' string modifier
case_PS:
	ldx	#F2_PSSTRING

setmod:
	cmp	#MODSTAGE
	bcs	?err			; skip
	txa
	tsb	fmtmod	
	lda	#MODSTAGE		; set final stage
	clc				; OK
	clv				; continue parsing
?err:	rts

;---------------------------------------------------------------------------
; specifier format checking -- these funtions checks type and modifiers
; flags in status register are set according check result:
;
;	CF = 1 => error, modifier not allowed
;	CF = 0, VF = 1 => ok -- X = conversion function index
;---------------------------------------------------------------------------
	
; case 'X' -- type unsigned integer hexadecimal upper case digits
case_HE:
	lda	#F2_CAPS		; set CAPS bit
	tsb	fmtmod
	
; case 'x' -- type unsigned integer hexadecimal upper case digits
case_he:
	lda	#F2_SIGNED
	trb	fmtmod			; clear signed bit
	lda	fmtflag
	bit	#F_PREC
	beq	?skp
	lda	#F_FILLZ		; ignore left '0' padding...
	trb	fmtflag			; ...if specified 'precision'
?skp:	ldx	#T_HEX			; conversion function index
	lda	#MASKINTG		; not allowed modifiers for integers
	bra	case_end

; case 'd', 'i' -- type decimal signed integer
case_de:
	lda	#F2_SIGNED
	tsb	fmtmod			; set signed bit
	bra	case_i			; common code for decimal integers

; case 'u' -- type decimal unsigned integer
case_un:
	lda	#F2_SIGNED
	trb	fmtmod			; clear signed bit

; common code for decimal integers
case_i:
	lda	fmtflag
	bit	#F_PREC
	beq	?skp
	lda	#F_FILLZ		; ignore left '0' padding...
	trb	fmtflag			; ...if specified 'precision'
?skp:	lda	#F_ALTFMT
	trb	fmtflag			; ignore alternate format
	ldx	#T_INT			; conversion function index
	lda	#MASKINTG		; not allowed modifiers for integers
	bra	case_end

; case 'c' -- type char
case_ch:
	lda	#(F_ALTFMT.OR.F_PREC)	; ignore precision and alternate format
	trb	fmtflag
	ldx	#T_CHAR			; conversion function index
	lda	#MASKCHAR		; not allowed modifiers for chars
	bra	case_end
	
; case 's' -- type string
case_st:
	lda	#F_ALTFMT		; ignore alternate format
	trb	fmtflag
	ldx	#T_STR			; conversion function index
	lda	#MASKSTR		; not allowed modifiers for strings
	bra	case_end

; case 'E' -- type float exponential format (upper case 'E')
case_FE:
	lda	#'E'			; format 'E'
	bra	case_f

; case 'e' -- type float exponential format (lower case 'e')
case_fe:
	lda	#'e'			; format 'e'
	bra	case_f
	
; case 'G' -- type float format 'G'
case_FG:
	lda	#'G'			; format 'G'
	bra	case_f

; case 'g' -- type float format 'g'
case_fg:
	lda	#'g'			; format 'g'
	bra	case_f
	
; case 'A' -- type float hexadecimal upper case digits
case_XF:
	lda	#F_FILLZ		; ignore left '0' padding
	trb	fmtflag
	lda	#'A'			; format 'A'
	bra	case_f

; case 'a' -- type float hexadecimal lower case digits
case_xf:
	lda	#F_FILLZ		; ignore left '0' padding
	trb	fmtflag
	lda	#'a'			; format 'a'
	bra	case_f

; case 'K' -- type compact float hexadecimal lower case digits
case_KF:
	lda	#F_FILLZ		; ignore left '0' padding
	trb	fmtflag
	lda	#'K'			; format 'K'
	bra	case_f

; case 'k' -- type compact float hexadecimal upper case digits
case_kf:
	lda	#F_FILLZ		; ignore left '0' padding
	trb	fmtflag
	lda	#'k'			; format 'K'
	bra	case_f

; case 'f', 'F' -- type float decimal
case_ff:
	lda	#'f'			; format 'f'
	bra	case_f

case_FF:
	lda	#'F'			; format 'F'

; common code for float conversion
case_f:
	; float numbers can be left padded with '0'
	; even if specified 'precision' 
	sta	tfloat			; float format type  
	lda	#F2_SIGNED
	tsb	fmtmod			; set signed bit	
	ldx	#T_FLOAT		; conversion function index	
	lda	#MASKFLOAT		; not allowed modifiers for strings

; check modifier type
case_end:
	bit	fmtmod			; check not allowed modifiers
	beq	?ok			; OK
	sec				; error
	rts
?ok:	sep	#PVFLAG			; set VF = 1 
	clc				; no error
	rts

; case 'P' -- type pointer hexadecimal upper case digits
case_PT:
	lda	#F2_CAPS		; set CAPS bit
	tsb	fmtmod

; case 'p' -- type pointer hexadecimal lower case digits
case_pt:
	lda	#F2_SIGNED
	trb	fmtmod			; clear flag signed
	lda	#F_FILLZ		; ignore left '0' padding
	trb	fmtflag
	ldx	#T_PTR			; conversion function index
	lda	#MASKPTR		; not allowed modifiers for pointers
	bra	case_end

;---------------------------------------------------------------------------
; tables
;---------------------------------------------------------------------------

; character's class lookup table (32 <= char < 128)
CLASSCHR:

;            SP   !   "   #   $   %   &   '   (   )   *   +   ,   -   .   /
	.DB _si,_dc,_dc,_af,_dc,_dc,_dc,_dc,_dc,_dc,_ar,_si,_tg,_lj,_pr,_dc

;	      0   1   2   3   4   5   6   7   8   9   :   ;   <   =   >   ?
	.DB _fz,_nu,_nu,_nu,_nu,_nu,_nu,_nu,_nu,_nu,_dc,_dc,_dc,_dc,_dc,_dc

;             _   A   B   C   D   E   F   G   H   I   J   K   L   M   N   O
	.DB _dc,_XF,_PS,_dc,_dc,_FE,_FF,_FG,_dc,_dc,_dc,_KF,_ll,_dc,_dc,_dc

;             P   Q   R   S   T   U   V   W   X   Y   Z   [   \   ]   ^   _ 
	.DB _PT,_dc,_dc,_dc,_dc,_dc,_dc,_dc,_HE,_dc,_dc,_dc,_dc,_dc,_dc,_dc

;             `   a   b   c   d   e   f   g   h   i   j   k   l   m   n   o
	.DB _dc,_xf,_SH,_ch,_de,_fe,_ff,_fg,_sh,_de,_dc,_kf,_lo,_dc,_dc,_dc

;             p   q   r   s   t   u   v   w   x   y   z   {   |   }   ~ DEL 
	.DB _pt,_dc,_dc,_st,_dc,_un,_dc,_dc,_he,_dc,_dc,_dc,_dc,_dc,_dc,_dc

; table of specifiers checking functions
CHKTBL:
	.DW	case_dc, case_si, case_af, case_ar
	.DW	case_lj, case_pr, case_nu, case_lo
	.DW	case_sh, case_SH, case_fz, case_de
	.DW	case_un, case_he, case_pt, case_HE
	.DW	case_PT, case_ch, case_st, case_ff
	.DW	case_fe, case_fg, case_FE, case_FG
	.DW	case_tg, case_ll, case_PS, case_xf
	.DW	case_XF, case_kf, case_KF, case_FF
	
; tabella funzioni di conversione
CVTTBL:
;	.DW	DoChar, DoStr, DoPtr, DoInt, DoHex, DoFloat
	
NULLSTR:
	.DB	"(null)", 0
